package ProjectileDismemberment
{
   function ProjectileData::damage(%this, %obj, %col, %fade, %pos, %normal)
   {
   parent::damage(%this, %obj, %col, %fade, %pos, %normal);
      if(%col.gettype() & $TypeMasks::PlayerObjectType && fileName(%col.dataBlock.shapeFile) $= "m.dts")
   {
      %fvec = %col.getForwardVector();
      %vec1 = -getWord(%fvec,1) SPC getWord(%fvec,0) SPC 0;	
      %vec2 = vectorNormalize(%obj.initialVelocity);
      
      %damloc = (vectorDot(%vec1,%vec2) > 0);
      
      %scale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%scale)
      {
         %hidestr = "headskin";
         if(!%col.disHead)
            {
            %col.dishead = 1;
         %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemExplosionProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         for(%i=0;$hat[%i] !$= "";%i++) %hidestr = %hidestr SPC $hat[%i];
         for(%i=0;$accent[%i] !$= "";%i++) %hidestr = %hidestr SPC $accent[%i];
      }
      else if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 4.5*%scale)
      {
         if(%damLoc == 0)
         {
            %hidestr = "lhand lhook larm larmslim";
            if(!%col.dislhand)
            {
            %col.disLhand = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemLHandProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemshoulderProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         }
         else
         {
            %hidestr = "rhand rhook rarm rarmslim";
            if(!%col.dishand)
            {
            %col.dishand = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemHandProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemshoulderProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
         }
         }
      }
      else
      {
         if(%damLoc == 0)
         {
            %hidestr = "lshoe lpeg";
            if(!%col.dislfoot)
            {
            %col.disLfoot = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemFootProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         }
         else
         {
            %hidestr = "rshoe rpeg";
            if(!%col.disfoot)
            {
            %col.disfoot = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemFootProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         }
      }
      
      if(%col.dismembermentUnhideStr $= "")
         %col.dismembermentUnhideStr = "START";
      
      for(%i=0;%i<getWordCount(%hidestr);%i++)
      {
         %node = getWord(%hidestr,%i);
         if(%col.isNodeVisible(%node) && strStr(%col.dismembermentUnhideStr," " @ %node) == -1)
            %col.dismembermentUnhideStr = %col.dismembermentUnhideStr SPC %node;
         
         %col.hideNode(%node);
      }
      
      cancel(%col.dismembermentResetSched);
      %col.dismembermentResetSched = %col.schedule(5000,dismembermentReset);
   }

   //return Parent::Damage(%this, %obj, %col, %fade, %pos, %normal);
   }

   function Player::dismembermentReset(%this)
   {
      %this.spawnExplosion(playerTeleportProjectile.getID(),getWord(%this.getScale(),2)*0.75,%this.client);
      if(isObject(%this.client))
      {
         %this.unHideNode("headskin");
         %this.client.applyBodyParts();
         %this.client.applyBodyColors();
      }
      else
      {
         for(%i=1;%i<getWordCount(%this.dismembermentUnhideStr);%i++)
         %this.unHideNode(getWord(%this.dismembermentUnhideStr,%i));
         %this.dismembermentUnhideStr = "";
      }
      %this.disHand = 0;
      %this.disLHand = 0;
      %this.disHead = 0;
      %this.dislfoot = 0;
      %this.disfoot = 0;
   }

   function WeaponImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
   {
      parent::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
     if(%col.gettype() & $TypeMasks::PlayerObjectType && fileName(%col.dataBlock.shapeFile) $= "m.dts")
   {
      %fvec = %col.getForwardVector();
      %vec1 = -getWord(%fvec,1) SPC getWord(%fvec,0) SPC 0;	
      %vec2 = vectorNormalize(%obj.initialVelocity);
      
      %damloc = (vectorDot(%vec1,%vec2) > 0);
      
      %scale = getWord(%col.getScale(),2);
      if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%scale)
      {
         %hidestr = "headskin";
         if(!%col.disHead)
            {
            %col.dishead =1;
         %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemExplosionProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         for(%i=0;$hat[%i] !$= "";%i++) %hidestr = %hidestr SPC $hat[%i];
         for(%i=0;$accent[%i] !$= "";%i++) %hidestr = %hidestr SPC $accent[%i];
      }
      else if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 4.5*%scale)
      {
         if(%damLoc == 0)
         {
            %hidestr = "lhand lhook larm larmslim";
            if(!%col.dislhand)
            {
            %col.disLhand = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemLHandProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemshoulderProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         }
         else
         {
            %hidestr = "rhand rhook rarm rarmslim";
            if(!%col.dishand)
            {
            %col.dishand = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemHandProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemshoulderProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
         }
         }
      }
      else
      {
         if(%damLoc == 0)
         {
            %hidestr = "lshoe lpeg";
            if(!%col.dislfoot)
            {
            %col.disLfoot = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemFootProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         }
         else
         {
            %hidestr = "rshoe rpeg";
            if(!%col.disfoot)
            {
            %col.disfoot = 1;
            %proj = new Projectile()
            {
               scale = %col.getScale();
               dataBlock = DismemFootProjectile;
               initialVelocity = %col.getVelocity();
               initialPosition = %col.getPosition();
               sourceObject = %col;
               sourceSlot = 0;
               client = %col.client;
            };
            MissionCleanup.add(%proj);
            }
         }
      }
      
      if(%col.dismembermentUnhideStr $= "")
         %col.dismembermentUnhideStr = "START";
      
      for(%i=0;%i<getWordCount(%hidestr);%i++)
      {
         %node = getWord(%hidestr,%i);
         if(%col.isNodeVisible(%node) && strStr(%col.dismembermentUnhideStr," " @ %node) == -1)
            %col.dismembermentUnhideStr = %col.dismembermentUnhideStr SPC %node;
         
         %col.hideNode(%node);
      }
      
      cancel(%col.dismembermentResetSched);
      %col.dismembermentResetSched = %col.schedule(5000,dismembermentReset);
   }
   }
};
activatepackage(ProjectileDismemberment);

datablock DebrisData(dismemheadDebris)
{
   shapeFile = "./head.dts";
   lifetime = 6.0;
   minSpinSpeed = -400.0;
   maxSpinSpeed = 200.0;
   elasticity = 0.5;
   friction = 0.2;
   numBounces = 3;
   staticOnMaxBounce = true;
   snapOnMaxBounce = false;
   fade = true;
   gravModifier = 2;
};
datablock DebrisData(dismemhandDebris : dismemheadDebris)
{
   shapeFile = "./hand.dts";
};
datablock DebrisData(dismemhandLeftDebris : dismemheadDebris)
{
   shapeFile = "./handLeft.dts";
};
datablock DebrisData(dismemshoulderDebris : dismemheadDebris)
{
   shapeFile = "./shoulder.dts";
};
datablock DebrisData(dismemfootDebris : dismemheadDebris)
{
   shapeFile = "./foot.dts";
};
datablock ProjectileData(DismemExplosionProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage     = 10;
   directDamageType = $DamageType::Default; //Damagetype default actually does no damage
   radiusDamageType = $DamageType::Default;
   impactImpulse    = 10;
   verticalImpulse  = 10;
   explosion        = dismemExplosion;

   brickExplosionRadius            = 0;
   brickExplosionImpact            = false; 
   brickExplosionForce             = 0;
   brickExplosionMaxVolume         = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity   = 1;
   velInheritFactor = 1;

   lifetime         = 10;
   bounceElasticity = 0;
   bounceFriction   = 0;
   isBallistic    = false;
   explodeOnDeath = true;
   hasLight       = false;
};
datablock ExplosionData(dismemExplosion) //Gotta make sub-explosions first because an explosion has to exist to be a part of another explosion...
{
   lifetimeMS = 33;
   particleEmitter = "";
   debrisNumVariance      = 0;
   debrisPhiMin           = 0;
   debrisPhiMax           = 360;
   debrisThetaMin         = 5;
   debrisThetaMax         = 105;
   debrisVelocity         = 5;
   debrisVelocityVariance = 1;

   debris = dismemheadDebris;
   debrisNum = 1;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;

   lightStartRadius = 0;
   lightEndRadius = 0;

   impulseRadius = 100;
   impulseForce = 100;

   radiusDamage = 0;
   damageRadius = 0;
};
datablock ExplosionData(dismemExplosionFoot : dismemExplosion)
{
   debris = dismemfootDebris;
   debrisNum = 1;
   lifeTimeMS = 500;
   particleDensity = 45;
   particleRadius  = 2.5;
};
datablock ProjectileData(DismemFootProjectile : DismemExplosionProjectile)
{
 explosion = dismemExplosionFoot;  
};
datablock ExplosionData(dismemExplosionShoulder : dismemExplosion)
{
   debris = dismemshoulderDebris;
   debrisNum = 1;
   lifeTimeMS = 500;
   particleDensity = 45;
   particleRadius  = 2.5;
};
datablock ProjectileData(DismemShoulderProjectile : DismemExplosionProjectile)
{
 explosion = dismemExplosionShoulder;  
};
datablock ExplosionData(dismemExplosionHand : dismemExplosion)
{
   debris = dismemhandDebris;
   debrisNum = 1;
   lifeTimeMS = 500;
   particleDensity = 45;
   particleRadius  = 2.5;
};
datablock ProjectileData(DismemHandProjectile : DismemExplosionProjectile)
{
 explosion = dismemExplosionHand;  
};
datablock ExplosionData(dismemExplosionLHand : dismemExplosion)
{
   debris = dismemHandLeftDebris;
   debrisNum = 1;
   lifeTimeMS = 500;
   particleDensity = 45;
   particleRadius  = 2.5;
};
datablock ProjectileData(DismemLHandProjectile : DismemExplosionProjectile)
{
 explosion = dismemExplosionLHand;  
};